// HPCSE I: MPI_Send() on rank 0, MPI_Irecv()+MPI_Wait on rank 1
#include <mpi.h>
#include <stdio.h>
#include <unistd.h>

int main(int argc, char** argv)
{
	MPI_Init(&argc, &argv);

	int rank, size;
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	if (rank == 0)
	{
		double x=99; 

		sleep(1);
		MPI_Send(&x, 1, MPI_DOUBLE, 1, 8888, MPI_COMM_WORLD);
	}
	else if (rank == 1)
	{
		double y=0;

		MPI_Request request;
		MPI_Status status;

		MPI_Irecv(&y, 1, MPI_DOUBLE, 0, 8888, MPI_COMM_WORLD, &request);
		printf("rank %d: y = %lf\n", rank, y);
		MPI_Wait(&request, &status);
		printf("rank %d: y = %lf\n", rank, y);
	}

	return 0;
}
