// Example codes for HPC course
// (c) 2017 Panos Hadjidoukas, ETH Zurich

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main(int argc, char** argv) {
  MPI_Status status;
  int num;
  
  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&num);

  int N = 1024;
  if (argc == 2) N = atoi(argv[1]);

  char *ds=(char *)calloc(1, N*sizeof(char)); // to send (not needed on rank 1)
  char *dr=(char *)calloc(1, N*sizeof(char)); // to recv (not needed on rank 0)

  int tag=99;
  
  if(num==0) {
    MPI_Send(ds,N,MPI_CHAR,1,tag,MPI_COMM_WORLD);
  }
  else {
    MPI_Recv(dr,N/2,MPI_CHAR,0,tag,MPI_COMM_WORLD,&status);

    int count;
    MPI_Get_count(&status,MPI_CHAR,&count); 
    printf("status.MPI_SOURCE = %d, status.MPI_TAG = %d, count = %d\n", 
		status.MPI_SOURCE, status.MPI_TAG, count);

  }
  
  MPI_Finalize();
  return 0;
}
